/**
 * Apple Worldwide Developer Technical Support
 *
 * Sample showing how to send and receive AppleEvents using JDirect 2.
 *
 * File: NativeException.java
 *
 * This class represents a native error returned from a JDirect 2 Mac OS Toolbox call.
 *
 * @author Levi Brown
 * @author Apple Computer, Inc.
 *
 * Copyright 1999 Apple Computer, Inc.
 * All rights reserved.
 *
 * @version 1.0
 * 4/15/1999 Shipped as 'AppleEvent Send and Receive' sample.
 *
 * You may incorporate this sample code into your applications without
 * restriction, though the sample code has been provided "AS IS" and the
 * responsibility for its operation is 100% yours.  However, what you are
 * not permitted to do is to redistribute the source as "Apple Sample
 * Code" after having made changes. If you're going to re-distribute the
 * source, we require that you make it clear in the source that the code
 * was descended from Apple Sample Code, but that you've made changes.
 */
public class NativeException extends Exception
{
	/**
	 * Create a new NativeException object with a message and a corresponding error number.
	 * @param the message associated with this exception.
	 * @param the native error number causing the exception.
	 */
	public NativeException(String message, short errorNum)
	{
		super(message);
		
		this.errNum = errNum;
	}
	
	/**
	 * Get the native error number associated with this exception.
	 * @return the error number.
	 */
	public short getErrNum()
	{
		return errNum;
	}
	
	protected short errNum;
}